#!/bin/sh
#based on info from: http://osxdaily.com/2007/10/29/how-to-add-a-user-from-the-os-x-command-line-works-with-leopard/

exit;	#using root:wheel now

syncEmUserName="_syncem";
syncEmRealUserName="SyncEm Engine";

syncEmGroupName="$syncEmUserName";

dsclCmd="/usr/bin/dscl /Local/Default/";

#check if syncem user and group already exist
output=`$dsclCmd -read /Users/$syncEmUserName`
if /bin/test "$output"
then
	#user exists
	output=`$dsclCmd -read /Groups/$syncEmGroupName`
	if /bin/test "$output"
	then
		#group exist
		echo "User $syncEmUserName and group $syncEmGroupName already exist.";
		exit 0;
	fi
fi

set getUidToUseReturn="";
getUidToUse()
{
	theUid=74;
	while true
	do
		#echo "$theUid";
		output=`$dsclCmd -search /Users UniqueID $theUid`;
		#echo $output
		if /bin/test ! "$output"
		then
			#this uid is not use
			#echo "this uid is not in use";

			#now check if we can use it for the group
			output=`$dsclCmd -search /Groups PrimaryGroupID $theUid`;
			#echo $output
			if /bin/test ! "$output"
			then
				#this guid is not in use
				#echo "NOT IN USE $theUid"
				getUidToUseReturn=$theUid;
				return 1;
			fi
		fi
		
		theUid=`expr $theUid + 1`;
	done
}
getUidToUse;
newUid=$getUidToUseReturn;	#gets return value

echo "Creating user $syncEmUserName and group $syncEmGroupName with uids $newUid...";

#create user
createUser()
{
	theUid=$1

	$dsclCmd -create /Users/$syncEmUserName
	#Create and set the shell property
	$dsclCmd -create /Users/$syncEmUserName UserShell /usr/bin/false
	#Create and set the users full name.
	$dsclCmd -create /Users/$syncEmUserName RealName "$syncEmRealUserName"
	#Create and set the users ID.
	$dsclCmd -create /Users/$syncEmUserName UniqueID $theUid
	#Create and set the users group ID property.
	$dsclCmd -create /Users/$syncEmUserName PrimaryGroupID $theUid
	#Create and set the user home directory.
	$dsclCmd -create /Users/$syncEmUserName NFSHomeDirectory /var/Empty

	$dsclCmd -create /Users/$syncEmUserName passwd "*"
	$dsclCmd -create /Users/$syncEmUserName URL "www.syncem.com"
}
createUser $newUid;


#create group
createGroup()
{
	theGuid=$1

	$dsclCmd -create /Groups/$syncEmGroupName
	$dsclCmd -create /Groups/$syncEmGroupName name $syncEmGroupName
	$dsclCmd -create /Groups/$syncEmGroupName passwd "*"
	$dsclCmd -create /Groups/$syncEmGroupName gid $theGuid
	$dsclCmd -create /Groups/$syncEmGroupName GroupMembership $syncEmUserName
}
createGroup $newUid;

echo "  created user $syncEmUserName & group $syncEmGroupName.";

exit 0;